import requests
import pandas as pd

class PricerunnerClient():
    
    
    def __init__(self, api_key: str) -> None:
        self.base_url = "https://api.pricerunner.com/public/"
        self.headers = {
            "accept": "application/json;charset=UTF-8",
            "tokenId": api_key,
        }
        pass

    def fetch_categories(self, country_code:str) -> pd.DataFrame:
        """Fetches all categories from the PriceRunner API and returns a DataFrame"""
        url = f"{self.base_url}v1/categories/{country_code}"

        response = requests.get(url, headers=self.headers)

        # The response body can be accessed with response.json()

        df = pd.json_normalize(response.json(), record_path=["categories"])
        
        return df